

#ifdef include_range_type
include_range_type(SPIN,2)
#else

#ifdef __ranges_header__
// assert, that this is only used within range_types/header.h

#ifndef __range_type_spin_def__
#define __range_type_spin_def__

namespace MultiArrayTools
{
    typedef SingleIndex<size_t,SpaceType::SPIN> SpinIndex;

    template <>
    class SingleRangeFactory<size_t,SpaceType::SPIN> : public RangeFactoryBase
    {
    public:
	
	typedef SingleRange<size_t,SpaceType::SPIN> oType;

	SingleRangeFactory();
	std::shared_ptr<RangeBase> create();
	
    };

    template <>
    class SingleRange<size_t,SpaceType::SPIN> : public RangeInterface<SpinIndex>
    {
    public:
	typedef RangeBase RB;
	typedef typename RangeInterface<SingleIndex<size_t,SpaceType::SPIN> >::IndexType IndexType;
	typedef SingleRange<size_t,SpaceType::SPIN> RangeType;
	typedef size_t MetaType;
	
	virtual size_t size() const final;
	virtual size_t dim() const final;

	virtual std::string stringMeta(size_t pos) const final;
	virtual std::vector<char> data() const final;

	virtual SpaceType spaceType() const final;
        virtual DataHeader dataHeader() const final;
        
	size_t get(size_t pos) const;
	size_t getMeta(size_t metaPos) const;
	
	virtual IndexType begin() const final;
	virtual IndexType end() const final;
	//virtual std::shared_ptr<VIWB> index() const final;
	
	friend SingleRangeFactory<size_t,SpaceType::SPIN>;

	static constexpr bool defaultable = true;
	static constexpr size_t mSpinNum = 4;

	static constexpr size_t ISSTATIC = 1;
	static constexpr size_t SIZE = mSpinNum;
	static constexpr bool HASMETACONT = false;
	
	static SingleRangeFactory<size_t, SpaceType::SPIN> factory()
	{ return SingleRangeFactory<size_t, SpaceType::SPIN>(); }
	
    protected:

	SingleRange() = default;
	SingleRange(const SingleRange& in) = delete;

	//SingleRange(size_t spinNum);
    };

    typedef SingleRange<size_t,SpaceType::SPIN> SpinRange;
    typedef SingleRangeFactory<size_t,SpaceType::SPIN> SpinRF;

    std::shared_ptr<SpinRF> mkSPIN(const char* dp, size_t size);
}


#endif // #ifndef __range_type_spin_def__

#endif // #ifdef __ranges_header__

#endif // #ifdef include_range_type
